﻿#Please give the deployment folder
$DeploymentFolderName = "BuildFolderTemplate"



$logfile = "$PSScriptRoot\$DeploymentFolderName $(get-date -format `"yyyyMMdd_hhmmsstt`") Log.txt"
$RootFolder = $PSScriptRoot | Split-path
#$parentDeploymentFolderPath = "$RootFolder\$( get-date -format `"dd.MM.yyyy`")"
$parentDeploymentFolderPath = "$RootFolder\$DeploymentFolderName"
"#########################################################################" |  out-file -Filepath $logfile -append
 Write-Host "Deploying from folder $parentDeploymentFolderPath"  
"Deploying from folder $parentDeploymentFolderPath. Execution start time $(get-date -format `"yyyy.MM.dd hh:mm:ss tt`") "  |  out-file -Filepath $logfile -append
$psfiles = Get-ChildItem  $PSScriptRoot -Recurse | where-object {$_.extension  -eq ".ps1" -And $_.Name  -ne "Caller.ps1"} 

$Overallstatus = 1
  # deploying many scripts so iterate through the files
  foreach($psfile in $psfiles.FullName) 
  {
"#########################################################################" |  out-file -Filepath $logfile -append

"executingg $psfile" | out-file  $logfile -append
$scriptpath = Get-Item $psfile | Resolve-Path 
$scriptpathrelative = Get-Item $psfile | Resolve-Path -Relative
$scriptpathrelative = $scriptpathrelative.Replace(".","") | Split-path
$Fullitemspath = $parentDeploymentFolderPath + $scriptpathrelative
$PSFilename =  split-path(Get-Item $psfile | Resolve-Path)-Leaf
$IsSuccess = 0

$Fullitemspath  |  out-file -Filepath $logfile -append

$IsSuccess = & $scriptpath $logfile  $Fullitemspath 
If ($IsSuccess -eq 1)
{
 Write-Host -ForegroundColor "Green"  "$PSFilename execution successful."
}
else
{
 Write-Host -ForegroundColor "Red" "$PSFilename execution failed, refer to $logfile file for more details" 
$Overallstatus = 0
}
  }
 Write-Host "#########################################################################"  
"#########################################################################" |  out-file -Filepath $logfile -append
If ($Overallstatus )
{
"End of deployment with success. Execution end time $(get-date -format `"yyyy.MM.dd hh:mm:ss tt`") "    |  out-file -Filepath $logfile -append
 Write-Host -ForegroundColor "Green" "End of deployment with success....." 
}
else
{
"End of deployment with failure(s). Execution end time $(get-date -format `"yyyy.MM.dd hh:mm:ss tt`") "    |  out-file -Filepath $logfile -append
 Write-Host -ForegroundColor "Red" "End of deployment with failure(s)....." 
}


