﻿Param
(
$LogFilePath,
$FolderPath
)

##param
###########################################################################################
$server = "Server Instance Name"  ## mandatory
$dbname = "Database Name"  ## mandatory
$sqlserveruserName = "sqlserveruser"       
$sqlserverPassword = "passwordforaboveuser"      

###########################################################################################

$logfile = $LogFilePath
 $isSuccess = 1
"-------------------------Start of $dbname scripts---------------------------------" |  out-file -Filepath $logfile -append

#Connect to MS SQL Server 
try 
{ 
    $SQLConnection = New-Object System.Data.SqlClient.SqlConnection 
    #The MS SQL Server user and password is specified 
    if($sqlserveruserName -and $sqlserverPassword) 
    { 
        $SQLConnection.ConnectionString = "Server=" + $server + ";Database="  + $dbname + ";User ID="  + $sqlserveruserName + ";Password="  + $sqlserverPassword + ";" 
    } 
    #The MS SQL Server user and password is not specified - using the Windows user credentials 
    else 
    { 
        $SQLConnection.ConnectionString = "Server=" + $server + ";Database="  + $dbname + ";Integrated Security=True" 
    } 
    $SQLConnection.Open() 
} 
#Error of connection 
catch 
{ 
     $Error[0]  |  out-file -Filepath $logfile -append
"-------------------------End of $dbname scripts---------------------------------" |  out-file -Filepath $logfile -append
 $isSuccess = 0
} 

# get all .sql file names from current directory

$sqlfiles = Get-ChildItem  $FolderPath | where-object {$_.extension  -eq ".sql"}


if ($sqlfiles)
{
  # deploying many files so iterate through the files
  foreach($runfile in $sqlfiles.name) 
  {
"-------------------------Start of $runfile---------------------------------" |  out-file -Filepath $logfile -append
         $SQLSTMT = ""  
         $IsSQLErr = $false 

   $SQLCommandText = @(Get-Content -Path $FolderPath\$runfile) 

   $SQLCommandText = $SQLCommandText + "go"

   
      foreach($SQLString in  $SQLCommandText) 
      { 
          if($SQLString.Trim().ToLower() -ne "go") 
          { 
            #Preparation of SQL packet 
            $SQLSTMT += $SQLString + "`n" 
          } 
          else 
          {  

            #Execution of SQL packet 
            try 
            { 

           if ($SQLSTMT.Trim() -ne "")
           {
                $SQLCommand = New-Object System.Data.SqlClient.SqlCommand($SQLSTMT, $SQLConnection) 
       		$value =  $SQLCommand.ExecuteScalar()
           }   
		$SQLSTMT = ""    
                  
            } 
             catch 
            { 
                $IsSQLErr = $true 
               $Error[0]  | out-file -Filepath $logfile -append
               "Execution failed " | out-file -Filepath $logfile -append
                $isSuccess = 0
                break
            } 

             $SQLSTMT = "" 
        }
   }
            if(!$IsSQLErr) 
              { 
                 "Execution success " | out-file -Filepath $logfile -append
 
            }  
"-------------------------End of $runfile---------------------------------" |  out-file -Filepath $logfile -append
   }
   
    
   } 
   else
   {
 "No .sql files to load in $FolderPath " | out-file -Filepath $logfile -append
   }

#Disconnection from MS SQL Server 
$SQLConnection.Close() 
"-------------------------End of $dbname scripts---------------------------------" |  out-file -Filepath $logfile -append

return  $isSuccess
##End of script

